/*  Example implementation of a binary search
    Copyright (C) 2002  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "algorithm.h"
#include <stdlib.h>

void*
binary_search (void* key, void* data[], cmp_func cmp, unsigned int sz)
{
  int front, part, back;
  front = 0;
  back = sz - 1;
  part = (front + back) / 2; /* partition */

  while (front <= back)
    {
      switch (cmp (key, data[part]))
	{
	case -1:
	  back = part - 1;
	  break;
	case 0:
	  return data[part];
	  break;
	case 1:
	  front = part + 1;
	  break;
      }
      part = (front + back) / 2;
    }

  return NULL; /* only get here if not found */
}


