/*  Example implementation of a Linear Search
    Copyright (C) 2002  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "algorithm.h"
#include <stdlib.h> /* NULL */
#include <stdio.h>

void*
linear_search (void* key, void* data[], cmp_func cmp, unsigned int sz)
{
  int i;

  for (i=0;i<sz;i++)
    {
      if (cmp (key, data[i]) == 0)
	return data[i];
    }

  /* we only get here if nothing was found */
  return NULL;
}
