/* sequence generator, written in C */

#include "sequence.h"
#include <stdlib.h>

static void seq_append (seq_type* seq, int num); /* appends num to seq */

seq_type
sequence (gen_func func, int start, int end, int increment)
{
  seq_type temp = {0, NULL};
  int curr;

  for (curr=start;curr<=end;curr+=increment)
    seq_append (&temp, func (curr));

  return temp;
}

void
seq_append (seq_type* seq, int num)
{
  if (seq->seq == NULL)
    seq->seq = malloc (sizeof (int));
  else
    seq->seq = realloc (seq->seq, sizeof (int) * (seq->len + 1));

  seq->seq[seq->len] = num;
  ++seq->len;
}

long int
sum (size_t length, int *seq)
{
  int i, sum = 0;

  for (i=0;i<length;++i)
    sum += seq[i];

  return sum;
}
