;    Bubble Sort Algorithm Example
;    Copyright (C) 2002  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


;; bubble-sort vec: vector to search in, cmp: comparison function 
;; modifies vec in place

(load "vswap.scm")

(define bubble-sort
  (lambda (vec cmp)
    (if (not (vector? vec))
	(throw 'type-error)) ;; vec must be a vector
    (let ((length-of-vec (- (vector-length vec) 1)))
      (let outer ((i 0))
	(let inner ((j length-of-vec))
	  (if (> j i)
	      (begin
		(if (< (cmp (vector-ref vec j) (vector-ref vec (- j 1))) 0)
		    (vswap vec j (- j 1)))
		(inner (- j 1)))))
	(if (< i length-of-vec)
	    (outer (+ i 1)))))
    vec ))