;    Prime Number Testing Algorithm Example
;    Copyright (C) 2002  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;; Tests if a number if prime or not

;;; prime?
;;; determines if a number if prime
(define (prime? n)
  (= n (find-div n 2)))

;;; finds a divisor for n that is:
;;; guess <= divisor <= (sqrt n)
(define (find-div n guess) 
  (define (next x) ; returns 3 if n = 2, n + 2 otherwise
    (if (= x 2)
	3
	(+ x 2)))
  (cond ((> (expt guess 2) n) n)
	((= (remainder n guess) 0) guess)
	(else (find-div n (next guess)))))