;    Stack Data Type - Example Library written in Scheme
;    Copyright (C) 2001  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(use-modules (srfi srfi-1))
(use-modules (ice-9 syncase))

(define make-stack
  (lambda ()
    (list )))

(define-syntax stack-push! ; push data onto the stack
  (syntax-rules ()
    ((stack-push! stack data)
     (set! stack (append stack (list data))))))

(define-syntax stack-pop! ; takes data from top of stack
  (syntax-rules ()
    ((stack-pop! stack)
     (if (null? stack)
       (throw 'null-stack)
       (let ((temp (last stack)))
	 (set! stack (take stack (- (length stack) 1)))
	 temp )))))

(define stack-peak ; peak at the top of the stack
  (lambda (stack)
    (if (null? stack)
	(throw 'null-stack) ; stack has no data, throw exception
	(last stack))))