;;; seq takes 4 arguments:
;;; func: function that takes one argument: num
;;;       func must return a value using num
;;; start, end: the start and end of the sequence
;;; increment: how much to increment between steps
;;; generates a seq by applying func to start <= x <= end

(define (seq func start end increment)
  (let loop ((curr start)
	     (value (func start))
	     (sequence (list))
	     (next (+ start increment))) ; optimization that reduces addition
    (if (> curr end)
      (reverse sequence)
      (loop next (func next)
	    (cons value sequence) (+ next increment)))))
      